<?php


use Zend\Barcode\Object\Error;

class administrationmodule extends AbstractPage {

	private $page = NULL;

	public function __construct() {
		$this->needLicense = false;

		parent::__construct(array("Administration / Verwaltung"), false, true);

		$this->checkLogin();

	}

	public function execute() {
		/**
		 * 
		 * @var AbstractPage $module
		 */
		$module = $_REQUEST['module'];
		
		if(in_array($module, requesthandler::getAllowedActions())) {
			$this->page = $module;
		}
		else {
			new errorPage();
		}
		
		// Check Access
		
		
		
		if(!DB::getSession()->isAdmin()) {
		  new errorPage();
		}
		
	
		// Logbuch / Notizen
		
		if($_REQUEST['action'] == 'modulAddNote') {
			DB::getDB()->query("INSERT INTO modul_admin_notes (noteModuleName,noteText,noteUserID,noteTime)
					values(
						'" . $module . "',
						'" . DB::getDB()->escapeString($_POST['noteText']) . "',
						'" . DB::getSession()->getUserID(). "',
						UNIX_TIMESTAMP()
					)");
			header("Location: index.php?page=administrationmodule&module=" . $module);
			exit(0);
		}
		
		if($_REQUEST['action'] == 'deleteModuleNote') {
			DB::getDB()->query("DELETE FROM modul_admin_notes WHERE noteID='" . intval($_GET['noteID']) . "'");
			header("Location: index.php?page=administrationmodule&module=" . $module);
			exit(0);
		}
		
		$noteHTML = "";
		
		$notes = DB::getDB()->query("SELECT * FROM modul_admin_notes JOIN users ON userID=noteUserID WHERE noteModuleName='" . $module . "' ORDER BY noteTime DESC");
		while($n = DB::getDB()->fetch_array($notes)) {
			$noteHTML .= "<div class=\"callout callout-info\"><b>" . $n['userFirstName'] . " " . $n['userLastName'] . " (" . $n['userName'] . ")</b><br /><i>" . functions::makeDateFromTimestamp($n['noteTime']) . "</i><br />" . $n['noteText'] . "<br /><a href=\"index.php?page=administrationmodule&module=$module&action=deleteModuleNote&noteID={$n['noteID']}\"><i class=\"fa fa-trash\"></i></a></div>\r\n";
		}
		
		
	
		
		$html = $module::displayAdministration('index.php?page=administrationmodule&module=' . $this->page);
		
		
		// Einstellungen
		
		$hasSettings = $module::hasSettings();
		
		if($hasSettings) {
			$settings = $module::getSettingsDescription();
			
			for($s = 0; $s < sizeof($settings); $s++) {
				if($_REQUEST['action'] == "modulesavesettings") {
					switch($settings[$s]['typ']) {
						case "BOOLEAN":
							if($_POST[$settings[$s]['name']] == 1) {
								$saveValue = 1;
							}
							else $saveValue = 0;
							break;
			
						case "TEXT":
						case 'HTML':
							$saveValue = $_POST[$settings[$s]['name']];
							break;
			
						case "NUMMER":
							$saveValue = intval($_POST[$settings[$s]['name']]);
							break;
			
						case "ZEILE":
							$saveValue = $_POST[$settings[$s]['name']];
							break;
						
						case 'UHRZEIT':
							$saveValue = intval($_POST[$settings[$s]['name'] . '_h']) . ":" . intval($_POST[$settings[$s]['name'] . '_m']);
						break;
						
						case 'SELECT':
							$saveValue = $_POST[$settings[$s]['name']];
						break;
					}
			
					DB::getDB()->query("INSERT INTO settings (settingName, settingValue) values('" . $settings[$s]['name'] . "','" . DB::getDB()->escapeString(($saveValue)) . "') ON DUPLICATE KEY UPDATE settingValue='" . DB::getDB()->escapeString($saveValue) . "'");
				}
				else {
					switch($settings[$s]['typ']) {
						case "BOOLEAN":
							if(DB::getSettings()->getValue($settings[$s]['name']) == 1) {
								$selectedTrue = " checked=\"checked\"";
							}
							else {
								$selectedTrue = "";
							}
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/boolean") . "\";");
							break;
			
						case "TEXT":
							$value = DB::getSettings()->getValue($settings[$s]['name']);
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/text") . "\";");
							break;
			
						case "NUMMER":
							$value = DB::getSettings()->getValue($settings[$s]['name']);
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/nummer") . "\";");
							break;
			
						case "ZEILE":
							$value = DB::getSettings()->getValue($settings[$s]['name']);
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/zeile") . "\";");
							break;
			
						case "HTML":
							$value = DB::getSettings()->getValue($settings[$s]['name']);
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/html") . "\";");
							break;
							
						case 'SELECT':
							$value = DB::getSettings()->getValue($settings[$s]['name']);
							
							$selectOptions = '';
							$options = $settings[$s]['options'];
							for($i = 0; $i < sizeof($options); $i++) {
								$selectOptions .= '<option value="' . $options[$i]['value'] . '"' . (($value == $options[$i]['value']) ? (' selected="selected"') : ('')) . '>' . $options[$i]['name'] . '</option>';
							}
							
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/select") . "\";");
						break;
							
						case 'UHRZEIT':
							$value = DB::getSettings()->getValue($settings[$s]['name']);
							$minuten = explode(":",$value)[1];
							$stunden = explode(":",$value)[0];
							
							
							
							eval("\$settingsHTML .= \"" . DB::getTPL()->get("administration/settings/uhrzeit") . "\";");
							break;
					}
				}
			}
		}
		
		if($_REQUEST['action'] == 'modulesavesettings') {
			header("Location: index.php?page=administrationmodule&module=" . $module . "&settings=saved");
			exit(0);
		}
		
		
		
		eval("DB::getTPL()->out(\"" . DB::getTPL()->get("administration/module/index") . "\");");
		exit(0);
		
	}
	
	private function ajaxCompleteUserName() {
		$term = DB::getDB()->escapeString($_REQUEST['term']);
		header("Content-type: text/plain");
		
		
		echo("[\r\n");
		
		
		if(strlen($term) > 2) {
			$users = DB::getDB()->query("SELECT userID, userName, userFirstName, userLastName FROM users WHERE userName LIKE '%" . $term . "%' OR userFirstName LIKE '%" . $term . "%' OR userLastName LIKE '%" . $term . "%'");

			$first = true;
			while($user = DB::getDB()->fetch_array($users)) {
				if(!$first) echo(",");
				if($first) {
					$first = false;
				}
				echo("{\"id\": \"" . $user['userID'] . "\",\r\n");
				echo("\"value\": \"" . $user['userID'] . "\",\r\n");
				echo("\"label\": \"" . addslashes($user['userName'] . " (" . $user['userFirstName'] . " " . $user['userLastName']) . ")\"}\r\n");
			}
		}
		
		
		echo("]\r\n");
	}

	/**
	 * Zeigt einen Kasten an, mit dem Benutzer zur Gruppe $userGroup hinzugefügt oder entfernt werden können.
	 * 
	 * @param unknown $selfURL URL zur Administration
	 * @param unknown $name interner Name des Blocks (ohne Leerzeichen)
	 * @param unknown $actionAdd Aktion zum Hinzufügen
	 * @param unknown $actionDelete Aktion zum Löschen
	 * @param unknown $title Titel des Blocks
	 * @param unknown $beschreibung Beschreibung des Blocks
	 * @param unknown $userGroup Benutzergruppe
	 * @return string
	 */
	public static function getUserListWithAddFunction($selfURL, $name, $actionAdd, $actionDelete, $title, $beschreibung, $userGroup) {
		$html = "";
		
		$userGroup = usergroup::getGroupByName($userGroup);
		
		for($i = 0; $i < sizeof($userGroup->getMembers()); $i++) {
			$displayName = $userGroup->getMembers()[$i]->getDisplayNameWithFunction();
		
			$userList .= "<tr><td>" . $displayName . "</td><td style=\"width:10%\"><a href=\"$selfURL&action=$actionDelete&userID=" . $userGroup->getMembers()[$i]->getUserID() . "\"><i class=\"fa fa-trash\"></i></a></td></tr>";
		
		}
		
		
		eval("\$html .= \"" . DB::getTPL()->get("administration/module/personslist") . "\";");
		
		return $html;
	}

	public static function hasSettings() {
		return false;
	}

	/**
	 * Stellt eine Beschreibung der Einstellungen bereit, die für das Modul nötig sind.
	 * @return array(String, String)
	 * array(
	 * 	   array(
	 * 		'name' => "Name der Einstellung (z.B. formblatt-isActive)",
	 *		'typ' => ZEILE | TEXT | NUMMER | BOOLEAN,
	 *      'titel' => "Titel der Beschreibung",
	 *      'text' => "Text der Beschreibung"
	 *     )
	 *     ,
	 *     .
	 *     .
	 *     .
	 *  )
	 */
	public static function getSettingsDescription() {
		return array();
	}


	public static function getSiteDisplayName() {
		return 'Administration Einstellungen der Einstellungen';
	}

	/**
	 * Liest alle Nutzergruppen aus, die diese Seite verwendet. (Für die Benutzeradministration)
	 * @return array(array('groupName' => '', 'beschreibung' => ''))
	 */
	public static function getUserGroups() {
		return array();

	}

	public static function siteIsAlwaysActive() {
		return true;
	}
	
	public static function hasAdmin() {
		return false;
	}

}


?>